package LeidenUniv.Tracking;


import java.util.ArrayList;
import java.util.List;
import ij.*;

public class ObjectArray {
	
	OAcolumns[] OA;
	int sizeofOA;
	
	ObjectArray(int size){
		
		OA = new OAcolumns[size];
		
		for (int i=0; i<size; i++){
			OA[i] = new OAcolumns();
		}
		sizeofOA = size;
		
	}
	
	public boolean get(int spaceindex, int index){
		try {
			OA[spaceindex].get(index);	
			if (OA[spaceindex].get(index)!=null){
				getreal(spaceindex, index);
				return true;
			} else {
			return false;
			}
		} catch (IndexOutOfBoundsException e) {
			return false;
		}
		 
	}
	
	public FociObject getreal(int spaceindex, int index){
		return OA[spaceindex].get(index);
	}
	
	public void add(int spaceindex, FociObject F){
		 OA[spaceindex].addFoci(OA[spaceindex].size(), F);
	}
	
	public void set(int spaceindex, int i, FociObject F){
		OA[spaceindex].addFoci(i, F);
	}
	
	public int size(int index){
		return OA[index].size();
	}
	
	public Integer[] find(int index, FociObject F){
		List<Integer> indices = new ArrayList<Integer>(1);
		// int[] indices = new int[0];
		for (int i=0; i<OA[index].size(); i++){
			if (OA[index].get(i) == F){
				indices.add(i);	
			}
		}
		
		Integer[] returnvalue = indices.toArray(new Integer[indices.size()]);
		return returnvalue;
	}	
	
	public void print(){
		for (int i=0; i<this.sizeofOA; i++){
			for (int j=0; j<this.size(i); j++){
				if (this.get(i,j)){
				//for (int k=0; k<this.sizeofOA; k++){
				IJ.log(""+OA[i].get(j).x_coord+" "+OA[i].get(j).y_coord);
				} else {
					IJ.log(" blank ");
				}
			}
			IJ.log("\n");		
		}
	}
	
	public void resize(int colnum){
		int maxsize = OA[colnum].size();
		
		//for (int i=colnum+1; i<this.sizeofOA; i++) {
		  for (int i=0; i<this.sizeofOA; i++){
			for (int j=OA[i].size(); j<maxsize; j++){
				OA[i].addFoci(j, new FociObject());
			}
	}
	}
}
